/**************************************************************************
* CMS89FXXXϵMCUݳ-ڲ԰
*   SendTouchKey_Internal.c
*     V1.1
* ޸ڣ2019/9/17
* ************************************************************************
* ʹ˵
* 1."SendTouchKey_Internal.h"Ҫ͵İԼҪ͵ģʽֽ
* 2."Setting_Send"װҪ͵
* 3.г"SendTouchKey"
**************************************************************************/
#include "SendTouchKey_Internal.h"
#include <stdlib.h>
#include "CheckTouchKey.h"

/***********************************************

************************************************/
volatile unsigned char Data_mask;						// 7~6Bitݸʽ 5~3Bit֡ 2~0Bit֡
volatile unsigned char Data_number,*Data_address;		//ݸݵַ

/***********************************************

************************************************/
unsigned char I2C_Read1bYTE(unsigned char ack);			//ڴ湤
unsigned char I2C_Write1bYTE(unsigned char data);
void I2C_WriteStop();
void I2C_WriteStart();
void I2C_WaitMoment();
void Setting_Send(void);
void SendTouchKey(void);


/**************************************************************************
* ƣSetting_Send
* ܣ֡
* ڲ
* ڲ
*     עѭͻ
**************************************************************************/
void Setting_Send(void)
{
	static volatile unsigned char Frame_number;			//ǰ֡
	unsigned char DataStart,DataEnd;					//ʼźͽ
	TouchDataSend *pData;
		
	if (Frame_number < Frame_size)
		Frame_number++;
	else
		Frame_number = 1;

	//
	Data_mask =  (SEND_MODE << 6) | (Frame_size << 3) | Frame_number;

	//÷Ͱı
	DataStart = Frame_number*5 - 5;						//ȡݿʼ
	
	if (KEY_NUMBER < Frame_number*5)
		Data_number = KEY_NUMBER - DataStart;
	else
		Data_number = 5;
					
	DataEnd = DataStart + Data_number;					//ȡݽ

	Data_address = pData = (char*)sendBuf;				//ȡͻʼַ

	//ݸ
	/******************************************************************
	*ڴ˴뷢ݣÿֻ5ͨ
	*******************************************************************/
	for (char i = DataStart;i < DataEnd;i++,pData++)
	{
		pData -> keyChannel = i;						//ͨ

		pData -> rawData = FactorRawDat[i];							//˲ֵ
		
		#if SEND_MODE >= 1
			pData -> baseLine = Disp_KeyDown[i];						//׼ֵ
		#endif

		#if SEND_MODE >= 2
			pData -> noiseData = Disp_KeyDownPro[i];					//ֵ	
		#endif
		
		#if SEND_MODE >= 3
			pData -> OtherData = NoiseDat[i];					//Ԥֵ
		#endif	
	}
}


/**************************************************************************
* ƣSendTouchKey
* ܣݺ
* ڲ
* ڲ
*     ע
**************************************************************************/
void SendTouchKey()
{
	unsigned char checksum,i;
	static bit F_Delay;
	
	asm("clrwdt");
	checksum = KEY_NUMBER;
								
	if (checksum)										//˰
	{	
		F_Delay ^= 1;
		if (F_Delay)									//͵ȴһѭ
		{
			Setting_Send();								//֡
			return;	
		}
		checksum = 2 + Data_number * sizeof(TouchDataSend) + 1; 	//
		//------------------ͨѶΪ   0xA0+ݳ+++------------------
		I2C_WriteStart();
		I2C_Write1bYTE(0xA0);							//ӵ
		I2C_Write1bYTE(checksum);						//ݸΪ  X*(ģʽ*2+3)+3  Xʾ

		//------------------Ϊ   ģʽ+֡+֡
		I2C_Write1bYTE(Data_mask);		
		checksum += Data_mask;
		Data_number = Data_number * sizeof(TouchDataSend);
		//------------------Ϊ   ͨ+ݵλ+ݸλ-------------------
		for(i = 0;i < Data_number;i++,Data_address++)
		{
			I2C_Write1bYTE(*Data_address);
			checksum += *Data_address;
		}
		
		I2C_Write1bYTE(checksum);						//У
		I2C_WriteStop();								//					
	}	
}


/*********************************************************************	
 IIC
	
*********************************************************************/

/******************************************************************
ܣIICźź
    עʼź-SCLΪߵƽʱSDAϷӸߵ͵ĵƽ仯
*******************************************************************/
void I2C_WriteStart()
{
	I2C_SDA_IO = 0;
	I2C_SCL_IO = 0;
	I2C_WaitMoment();
	
	I2C_SDA = 1;				//ȽSDA=1׼SCL=1ʱSDA=0
	I2C_SCL = 1;				//ʱ
	I2C_WaitMoment();
	I2C_SDA = 0;				//SCL=1ʱSDAͼź
	
	I2C_WaitMoment();
	I2C_SCL = 0;				//SCL=0źŲ
}

/******************************************************************
ܣIICźź
    עź-SCLΪߵƽʱSDAϷӵ͵ߵĵƽ仯
*******************************************************************/
void I2C_WriteStop()
{
	I2C_SDA_IO = 0;
	I2C_SCL_IO = 0;
	I2C_WaitMoment();
	
	I2C_SDA = 0;				//ȽSDA=0׼SCL=1ʱSDA=1
	I2C_SCL = 1;				//ʱ
	I2C_WaitMoment();
	I2C_SDA = 1;				//SCL=1ʱSDA߼ֹͣź
		
	I2C_WaitMoment();
	I2C_SCL = 0;				//SCL=0źŲ
}

/***********************************************************
ܣģIIC8λ
ڲdata-
أackӦź
    עIICЭackӦźΪЧ
***********************************************************/
unsigned char I2C_Write1bYTE(unsigned char data)
{
	unsigned char i = 8;
	I2C_SDA_IO = 0;
	I2C_SCL_IO = 0;
	do
	{
		I2C_SCL = 0;
		if(data&0x80)
			I2C_SDA = 1;
		else
			I2C_SDA = 0;
		
		I2C_SCL = 1;			//ʱһأһλд
		data <<= 1;
		asm("nop");	
	}
	while(--i);
	I2C_SCL = 0;
	
	I2C_SDA_IO = 1;				//ΪڽӦź

	I2C_WaitMoment();
	I2C_SCL = 1;				//׼Ӧź
	I2C_WaitMoment();
	
	i = I2C_SDA;
	I2C_SCL = 0;
	I2C_SDA_IO = 0;
	return i;
}

/***********************************************************
ܣģIIC8λ
ڲack-Ӧź
أյ
    עIICЭackӦźΪЧ
***********************************************************/
unsigned char I2C_Read1bYTE(unsigned char ack)
{
	unsigned char i,data;
	I2C_SDA_IO = 1;
	I2C_SCL_IO = 1;
	I2C_WaitMoment();
	
	while(!I2C_SCL);			//ȴӻ׼ͷʱ
	I2C_SCL_IO = 0;
	I2C_SCL = 0;
	I2C_WaitMoment();
	
	data <<= 1;
	if(I2C_SDA) data |= 0x1;
	
	
	for(i = 0; i < 7; i++)
	{
		I2C_SCL = 1;
		data <<= 1;
		if(I2C_SDA) data |= 0x1;
		I2C_SCL = 0;
	}
	
	I2C_SDA_IO = 0;
	
	if(ack)I2C_SDA = 1;			//ǷҪ
	else I2C_SDA = 0;
	
	I2C_WaitMoment();
	I2C_SCL = 1;
	I2C_WaitMoment();
	I2C_SCL = 0;
	return data;
}

//Ǿ׼ʱ
void I2C_WaitMoment()
{
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");	
}	
	
	